Index: /trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs	(revision 1838)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs	(revision 1839)
@@ -67,4 +67,5 @@
       titleShape.Font = viewSettings.TitleFont;
       titleShape.Color = viewSettings.TitleColor;
+      titleShape.Text = model.Title;
 
       legendShape.Font = viewSettings.LegendFont;
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.Designer.cs	(revision 1838)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.Designer.cs	(revision 1839)
@@ -42,4 +42,6 @@
       this.cbLegendPosition = new System.Windows.Forms.ComboBox();
       this.tpTitle = new System.Windows.Forms.TabPage();
+      this.label5 = new System.Windows.Forms.Label();
+      this.tbxTitle = new System.Windows.Forms.TextBox();
       this.btnChangeTitleFont = new System.Windows.Forms.Button();
       this.tpXAxis = new System.Windows.Forms.TabPage();
@@ -245,4 +247,6 @@
       // tpTitle
       // 
+      this.tpTitle.Controls.Add(this.label5);
+      this.tpTitle.Controls.Add(this.tbxTitle);
       this.tpTitle.Controls.Add(this.btnChangeTitleFont);
       this.tpTitle.Location = new System.Drawing.Point(4, 22);
@@ -253,7 +257,24 @@
       this.tpTitle.UseVisualStyleBackColor = true;
       // 
+      // label5
+      // 
+      this.label5.AutoSize = true;
+      this.label5.Location = new System.Drawing.Point(3, 6);
+      this.label5.Name = "label5";
+      this.label5.Size = new System.Drawing.Size(30, 13);
+      this.label5.TabIndex = 3;
+      this.label5.Text = "Title:";
+      // 
+      // tbxTitle
+      // 
+      this.tbxTitle.Location = new System.Drawing.Point(39, 3);
+      this.tbxTitle.Name = "tbxTitle";
+      this.tbxTitle.Size = new System.Drawing.Size(151, 20);
+      this.tbxTitle.TabIndex = 2;
+      this.tbxTitle.TextChanged += new System.EventHandler(this.tbxTitle_TextChanged);
+      // 
       // btnChangeTitleFont
       // 
-      this.btnChangeTitleFont.Location = new System.Drawing.Point(3, 3);
+      this.btnChangeTitleFont.Location = new System.Drawing.Point(193, 1);
       this.btnChangeTitleFont.Name = "btnChangeTitleFont";
       this.btnChangeTitleFont.Size = new System.Drawing.Size(94, 23);
@@ -353,4 +374,5 @@
       this.tabPage2.PerformLayout();
       this.tpTitle.ResumeLayout(false);
+      this.tpTitle.PerformLayout();
       this.tpXAxis.ResumeLayout(false);
       this.tpYAxes.ResumeLayout(false);
@@ -393,4 +415,6 @@
     private System.Windows.Forms.FlowLayoutPanel flpShowYAxis;
     private System.Windows.Forms.FontDialog fdFont;
+    private System.Windows.Forms.TextBox tbxTitle;
+    private System.Windows.Forms.Label label5;
   }
 }
Index: /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1838)
+++ /trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1839)
@@ -11,4 +11,5 @@
     private ViewSettings oldViewSettings;
     private LineParams[] oldLineParams;
+    private string oldTitle;
     private Dictionary<CheckBox, bool> ShowYAxisBoxes;
     private Dictionary<CheckBox, bool> yAxisClipChangeableBoxes;
@@ -55,4 +56,6 @@
       set {
         model = value;
+        oldTitle = model.Title;
+        tbxTitle.Text = model.Title;
         viewSettings = model.ViewSettings;
         oldViewSettings = new ViewSettings(model.ViewSettings);
@@ -73,4 +76,7 @@
         box.Key.Checked = box.Value;
       }
+
+      model.Title = oldTitle;
+      tbxTitle.Text = oldTitle;
 
       viewSettings.LegendColor = oldViewSettings.LegendColor;
@@ -231,4 +237,9 @@
       }
     }
+
+    private void tbxTitle_TextChanged(object sender, EventArgs e) {
+      model.Title = tbxTitle.Text;
+      model.ViewSettings.UpdateView();
+    }
   }
 }